/************************************************************************/
/*									*/
/*	DIF_HEL\512\CHNG_ACT.PRO			14.12.93	*/
/*									*/
/*	Andreas Rieke, Heusnerstr. 24, 42283 Wuppertal.			*/
/*									*/
/*	Diffie-Hellman-Schluesselaustausch mit 512 Bits. Dieses 	*/
/*	Protokoll stellt den aktiven Teil dar, d. h. der Schluessel-	*/
/*	austausch wird von hier angeregt.				*/
/*									*/
/*	Vorgaben:							*/
/*	  public: Pfad fuer oeffentliche Schluessel.			*/
/*									*/
/************************************************************************/


PROCESS dif_hel_512_chng_act;


DCL p, s, a, alpha, beta, k integer;
DCL public charstring;


START;

TASK public := 'f:/user/rieke/diplom/keys/public';

TASK p := load_int ( public // '/512/dif_hel.p' );
TASK s := load_int ( public // '/512/dif_hel.s' );

TASK a := rand_max ( p );
TASK alpha := mod_exp ( s, a, p );
OUTPUT dif_hel_msg ( alpha );
NEXTSTATE dif_hel;


STATE dif_hel;
  INPUT dif_hel_msg ( beta );
    TASK k := mod_exp ( beta, a, p );
    CALL writeln ( 'Diffie-Hellman-Schluesselaustausch durchgefuehrt:' );
    CALL writeln ( '  ', k );
    STOP;
ENDSTATE;
    

ENDPROCESS;
