/************************************************************************/
/*									*/
/*	DIF_HEL\512\CHNG_PAS.PRO			14.12.93	*/
/*									*/
/*	Andreas Rieke, Heusnerstr. 24, 42283 Wuppertal.			*/
/*									*/
/*	Diffie-Helmann-Schluesselaustausch mit 512 Bits. Dieses 	*/
/*	Protokoll stellt den passiven Teil dar, d. h. der Wunsch eines 	*/
/*	anderen Anwenders nach Schluesselaustausch wird hier 		*/
/*	beantwortet.							*/
/*									*/
/*	Vorgaben:							*/
/*	  public: Pfad fuer oeffentliche Schluessel.			*/
/*									*/
/************************************************************************/


PROCESS dif_hel_512_chng_pas;


DCL p, s, a, alpha, beta, k integer;
DCL public charstring;


START;

TASK public := 'f:/user/rieke/diplom/keys/public';

TASK p := load_int ( public // '/512/dif_hel.p' );
TASK s := load_int ( public // '/512/dif_hel.s' );

NEXTSTATE ready;


STATE ready;
  INPUT dif_hel_msg ( beta );
    TASK a := rand_max ( p );
    TASK alpha := mod_exp ( s, a, p );
    OUTPUT dif_hel_msg ( alpha );
    TASK k := mod_exp ( beta, a, p );
    CALL writeln ( 'Diffie-Hellman-Schluesselaustausch durchgefuehrt:' );
    CALL writeln ( '  ', k );
    NEXTSTATE ready;
ENDSTATE;
    

ENDPROCESS;
