/************************************************************************/
/*									*/
/*	DIF_HEL\CHNG_ACT.PRO				21.7.93		*/
/*									*/
/*	Andreas Rieke, Heusnerstr. 24, 42283 Wuppertal.			*/
/*									*/
/*	Diffie-Hellman-Schluesselaustausch. Dieses Protokoll stellt	*/
/*	den aktiven Teil dar, d. h. der Schluesselaustausch wird von	*/
/*	hier angeregt.							*/
/*									*/
/*	Vorgaben:							*/
/*	  bits:   Laenge der benutzten Schluessel.			*/
/*	  public: Pfad fuer oeffentliche Schluessel.			*/
/*									*/
/************************************************************************/


PROCESS dif_hel_chng_act;


DCL bits, p, s, a, alpha, beta, k integer;
DCL public, path charstring;


START;

TASK bits := 512;
TASK public := 'f:/user/rieke/diplom/keys/public';

TASK path := '/' // int2str ( bits );
TASK p := load_int ( public // path // '/dif_hel.p' );
TASK s := load_int ( public // path // '/dif_hel.s' );

TASK a := rand_max ( p );
OUTPUT dif_hel ( bits );
TASK alpha := mod_exp ( s, a, p );
OUTPUT dif_hel_msg ( alpha );
NEXTSTATE dif_hel;


STATE dif_hel;
  INPUT dif_hel_msg ( beta );
    TASK k := mod_exp ( beta, a, p );
    CALL writeln ( 'Diffie-Hellman-Schluesselaustausch mit ', bits,
		   ' Bits durchgefuehrt:' );
    CALL writeln ( '  ', k );
    STOP;
ENDSTATE;
    

ENDPROCESS;
