/************************************************************************/
/*									*/
/*	DIF_HEL\CHNG_PAS.PRO				21.7.93		*/
/*									*/
/*	Andreas Rieke, Heusnerstr. 24, 42283 Wuppertal.			*/
/*									*/
/*	Diffie-Helmann-Schluesselaustausch. Dieses Protokoll stellt 	*/
/*	den passiven Teil dar, d. h. der Wunsch eines anderen Anwenders	*/
/*	nach Schluesselaustausch wird hier beantwortet.			*/
/*									*/
/*	Vorgaben:							*/
/*	  public: Pfad fuer oeffentliche Schluessel.			*/
/*									*/
/************************************************************************/


PROCESS dif_hel_chng_pas;


DCL bits_partner, p, s, a, alpha, beta, k integer;
DCL public, path charstring;


START;

TASK public := 'f:/user/rieke/diplom/keys/public';

NEXTSTATE ready;


STATE ready;
  INPUT dif_hel ( bits_partner );
    TASK path := '/' // int2str ( bits_partner );
    TASK p := load_int ( public // path // '/dif_hel.p' );
    TASK s := load_int ( public // path // '/dif_hel.s' );
    
    TASK a := rand_max ( p );
    TASK alpha := mod_exp ( s, a, p );
    OUTPUT dif_hel_msg ( alpha );
    NEXTSTATE dif_hel;
ENDSTATE;

STATE dif_hel;
  INPUT dif_hel_msg ( beta );
    TASK k := mod_exp ( beta, a, p );
    CALL writeln ( 'Diffie-Hellman-Schluesselaustausch mit ', 
		   bits_partner, ' Bits durchgefuehrt:' );
    CALL writeln ( '  ', k );
    NEXTSTATE ready;
ENDSTATE;
    

ENDPROCESS;
