/************************************************************************/
/*									*/
/*	DIF_HEL\KEYS.PRO				21.7.93		*/
/*									*/
/*	Andreas Rieke, Heusnerstr. 24, 42283 Wuppertal.			*/
/*									*/
/*	Berechnet die Schluessel fuer einen Diffie-Hellman-		*/
/*	Schluesselaustausch.						*/
/*									*/
/*	Vorgaben:							*/
/*	  bits:   Laenge der Schluessel in binaerer Darstellung.	*/
/*	  public: Pfad fuer oeffentliche Schluessel.			*/
/*									*/
/************************************************************************/


PROCESS dif_hel_keys;


DCL bits, p, s integer;
DCL public, path charstring;


START;

TASK bits := 512;
TASK public := 'f:/user/rieke/diplom/keys/public';

TASK path := '/' // int2str ( bits );
CALL mkdir ( public // path );

TASK p := rand_bits_prime ( bits );
TASK s := rand_max ( p );

CALL store ( p, public // path // '/dif_hel.p' );
CALL store ( s, public // path // '/dif_hel.s' );

STOP;


ENDPROCESS;
