/************************************************************************/
/*									*/
/*	DSA\KEYS\COMMON.PRO				16.10.95	*/
/*									*/
/*	Andreas Rieke, Heusnerstr. 24, 42283 Wuppertal.			*/
/*									*/
/*	Berechnet die gemeinsamen Schluesssel fuer den digital 		*/
/*	signature algorithm (DSA).					*/
/*									*/
/*	Vorgaben:							*/
/*	  public: Pfad fuer oeffentliche Schluessel.			*/
/*	  bits:   Laenge der Schluessel in binaerer Darstellung.	*/
/*									*/
/************************************************************************/


PROCESS dsa_keys_common;


DCL public, path charstring;
DCL bits, q, minimum, maximum, n, p, h, g integer;


START;

TASK bits := 512;
TASK public := 'f:/user/rieke/diplom/keys/public';

TASK path := '/' // int2str ( bits );
CALL mkdir ( public // path );

TASK q := rand_bits_prime ( 160 );

MACRO repeat ( a );
  TASK minimum := ( exp ( 2, bits - 1 ) - 1 ) / ( 2 * q ) + 1;
  TASK maximum := ( exp ( 2, bits     ) - 1 ) / ( 2 * q );
  TASK n := minimum + rand_max ( maximum - minimum + 1 );
  TASK p := 2 * n * q + 1;
MACRO until ( is_prime ( p ) );

MACRO repeat ( b );
  TASK h := 1 + rand_max ( p - 2 );
  TASK g := mod_exp ( h, ( p - 1 ) / q, p );
MACRO until ( g /= 1 );

CALL store ( q, public // path // '/dsa.q' );
CALL store ( p, public // path // '/dsa.p' );
CALL store ( g, public // path // '/dsa.g' );

STOP;


ENDPROCESS;
