/************************************************************************/
/*									*/
/*	DSA\KEYS\USER.PRO				16.10.95	*/
/*									*/
/*	Andreas Rieke, Heusnerstr. 24, 42283 Wuppertal.			*/
/*									*/
/*	Berechnet die Anwenderschluessel fuer den DSA.			*/
/*									*/
/*	Vorgaben:							*/
/*	  user   : Name des Anwenders.					*/
/*	  bits   : Laenge der Schluessel in binaerer Darstellung.	*/
/*	  public : Pfad fuer oeffentliche Schluessel.			*/
/*	  private: Pfad fuer geheime Anwenderschluessel.		*/
/*									*/
/************************************************************************/


PROCESS dsa_keys_user;


DCL user, public, private, path charstring;
DCL bits, q, p, g, x, y integer;


START;

TASK user := 'Andreas';
TASK bits := 512;
TASK public  := 'f:/user/rieke/diplom/keys/public';
TASK private := 'f:/user/rieke/diplom/keys/private';

TASK path := '/' // int2str ( bits );
TASK q := load_int ( public // path // '/dsa.q' );
TASK p := load_int ( public // path // '/dsa.p' );
TASK g := load_int ( public // path // '/dsa.g' );

TASK path := '/' // user // path;
CALL mkdir ( public  // path );
CALL mkdir ( private // path );

TASK x := rand_max ( q );
TASK y := mod_exp ( g, x, p );

CALL store ( x, private // path // '/dsa.x' );
CALL store ( y, public  // path // '/dsa.y' );

STOP;


ENDPROCESS;
