/************************************************************************/
/*									*/
/*	DSA\SIGN.PRO					16.10.95	*/
/*									*/
/*	Andreas Rieke, Heusnerstr. 24, 42283 Wuppertal.			*/
/*									*/
/*	Protokoll zum Erzeugen einer digitalen Unterschrift mit Hilfe	*/
/*	des DSA-Algorithmus.						*/
/*									*/
/*	Vorgaben:							*/
/*	  user:    Name des Anwenders.					*/
/*	  bits:	   Laenge der Schluessel in binaerer Darstellung.	*/
/*	  message: Zu unterschreibende Nachricht.			*/
/*	  public:  Pfad fuer oeffentliche Schluessel.			*/
/*	  private: Pfad fuer geheime Anwenderschluessel.		*/
/*									*/
/************************************************************************/


PROCESS dsa_sign;


DCL user, message, public, private, path charstring;
DCL bits, q, p, g, x, k, t, r, h, s integer;


START;

TASK user := 'Andreas';
TASK bits := 512;
TASK message := 'Dies ist der zu unterschreibende Text.';
TASK public  := 'f:/user/rieke/diplom/keys/public';
TASK private := 'f:/user/rieke/diplom/keys/private';

TASK path := '/' // int2str ( bits );
TASK q := load_int ( public // path // '/dsa.q' );
TASK p := load_int ( public // path // '/dsa.p' );
TASK g := load_int ( public // path // '/dsa.g' );

TASK path := '/' // user // path;
TASK x := load_int ( private // path // '/dsa.x' );

TASK k := rand_max ( q );
TASK t := mod_exp ( g, k, p );
TASK r := t mod q;
TASK h := hash_md5 ( message );
TASK s := mod_mul ( rcp ( k, q ), h + x * r, q );

OUTPUT dsa ( user, message, bits, r, s );

STOP;


ENDPROCESS;
