/************************************************************************/
/*									*/
/*	DSA\VERIFY.PRO					16.10.95	*/
/*									*/
/*	Andreas Rieke, Heusnerstr. 24, 42283 Wuppertal.			*/
/*									*/
/*	Protokoll zum Ueberpruefen einer mit Hilfe des DSA erstellten	*/
/*	digitalen Unterschrift.						*/
/*									*/
/*	Vorgaben:							*/
/*	  public: Pfad fuer oeffentliche Schluessel.			*/
/*									*/
/************************************************************************/


PROCESS dsa_verify;


DCL partner, public, message, path charstring;
DCL bits_partner, q, p, g, y, r, s, h integer;
DCL w, u1, u2, a, b, t, v integer;


START;

TASK public := 'f:/user/rieke/diplom/keys/public';

NEXTSTATE ready;


STATE ready;
  INPUT dsa ( partner, message, bits_partner, r, s );
    TASK path := '/' // int2str ( bits_partner );
    TASK q := load_int ( public // path // '/dsa.q' );
    TASK p := load_int ( public // path // '/dsa.p' );
    TASK g := load_int ( public // path // '/dsa.g' );
    TASK path := '/' // partner // path;
    TASK y := load_int ( public // '/' // path // '/dsa.y' );
    TASK h := hash_md5 ( message );
    TASK w := rcp ( s, q );
    TASK u1 := mod_mul ( h, w, q );
    TASK u2 := mod_mul ( r, w, q );
    TASK a := mod_exp ( g, u1, p );
    TASK b := mod_exp ( y, u2, p );
    TASK t := mod_mul ( a, b, p );
    TASK v := t mod q;
    DECISION v = r;
      (true):
        CALL writeln ( 'DSA-Uebertragung von ', partner, ' mit ', 
                       bits_partner, ' Bits: positiv.' );
      ELSE:
        CALL writeln ( 'DSA-Uebertragung von ', partner, ' mit ',
		       bits_partner, ' Bits: negativ.' );
    ENDDECISION;
    CALL writeln ( '  ', message );
    NEXTSTATE ready;
ENDSTATE;


ENDPROCESS;
