/************************************************************************/
/*									*/
/*	EL_GAM\KEYS\COMMON.PRO				21.7.93		*/
/*									*/
/*	Andreas Rieke, Heusnerstr. 24, 42283 Wuppertal.			*/
/*									*/
/*	Protokoll zum Erzeugen der gemeinsamen Schluessel fuer das	*/
/*	ElGamal - Verschluesselungsschema.				*/
/*									*/
/*	Vorgaben:							*/
/*	  bits:   Laenge der Schluessel in binaerer Darstellung.	*/
/*	  public: Pfad fuer oeffentliche Schluessel.			*/
/*									*/
/************************************************************************/


PROCESS el_gam_keys_common;


DCL bits integer;			/* Laenge der Zahlen.		*/
DCL public, path charstring;
DCL p, s integer;


START;

TASK bits := 512;			/* Anzahl der Bits.		*/
TASK public := 'f:/user/rieke/diplom/keys/public';	
					/* Fuer oeffentliche Schluessel.*/

TASK path := '/' // int2str ( bits );
CALL mkdir ( public // path );

TASK p := rand_bits_prime ( bits );	/* Primzahl berechnen.		*/
TASK s := rand_max ( p );

CALL store ( p, public // path // '/el_gam.p' );
CALL store ( s, public // path // '/el_gam.s' );

STOP;


ENDPROCESS;
