/************************************************************************/
/*									*/
/*	EL_GAM\KEYS\USER.PRO				21.7.93		*/
/*									*/
/*	Andreas Rieke, Heusnerstr. 24, 42283 Wuppertal.			*/
/*									*/
/*	Protokoll zum Berechnen der Anwenderschluessel fuer das 	*/
/*	ElGamal - Verschluesselungsschema.				*/
/*									*/
/*	Vorgaben:							*/
/*	  bits:    Laenge der Schluessel in binaerer Darstellung.	*/
/*	  user:    Name des Anwenders.					*/
/*	  public:  Pfad fuer oeffentliche Schluessel.			*/
/*	  private: Pfad fuer geheime Anwenderschluessel.		*/
/*									*/
/************************************************************************/


PROCESS el_gam_keys_user;


DCL bits integer;
DCL user charstring;
DCL public, private, path charstring;
DCL p, s, b, beta integer;


START;

TASK bits := 512;			/* Anzahl der Bits.		*/
TASK user := 'Andreas';			/* Maximal 8 Zeichen.		*/

TASK public  := 'f:/user/rieke/diplom/keys/public';
TASK private := 'f:/user/rieke/diplom/keys/private';	

TASK path := '/' // int2str ( bits );
TASK p := load_int ( public // path // '/el_gam.p' );
TASK s := load_int ( public // path // '/el_gam.s' );

TASK path := '/' // user // '/' // int2str ( bits );
CALL mkdir ( public  // path );
CALL mkdir ( private // path );

TASK b := rand_max ( p );
TASK beta := mod_exp ( s, b, p );

CALL store ( b, private // path // '/el_gam.b'    );
CALL store ( beta, public  // path // '/el_gam.bet' );

STOP;


ENDPROCESS;
