/************************************************************************/
/*									*/
/*	EL_GAM\MULTIPLE\SEND.PRO			21.7.93		*/
/*									*/
/*	Andreas Rieke, Heusnerstr. 24, 42283 Wuppertal.			*/
/*									*/
/*	Protokoll zum Verschluesseln einer Nachricht mit Hilfe des	*/
/*	ElGamal-Verschluesselungsschemas.				*/
/*									*/
/*	Vorgaben:							*/
/*	  bits:    Laenge der Schluessel in binaerer Darstellung.	*/
/*	  partner: Name des Empfaengers.				*/
/*	  message: Zu verschluesselnde Nachricht.			*/
/*	  public:  Pfad fuer oeffentliche Schluessel.			*/
/*									*/
/************************************************************************/


PROCESS el_gam_mul_send;


DCL bits, block, c, d, i integer;
DCL partner charstring;
DCL message charstring;
DCL public, path charstring;
DCL p, s, beta, a, k integer;


START;

TASK bits := 512;			/* Anzahl der Bits.		*/
TASK partner := 'Andreas';		/* Maximal 8 Zeichen.		*/
TASK message := load_str ( 'f:/user/rieke/diplom/proto/secret.txt' );
TASK public := 'f:/user/rieke/diplom/keys/public';

TASK path := '/' // int2str ( bits );
TASK p := load_int ( public // path // '/el_gam.p'    );
TASK s := load_int ( public // path // '/el_gam.s'    );
TASK path := '/' // partner // path;
TASK beta := load_int ( public // path // '/el_gam.bet' );

OUTPUT el_gam_mul ( bits );

TASK i := 0;
MACRO repeat ( a );
  TASK block := pack ( message, i, bits - 1 );
  DECISION block = 0;
    (true):
      OUTPUT el_gam_mul_last;
    ELSE:
      TASK a := rand_max ( p );
      TASK d := mod_exp ( s, a, p );
      TASK k := mod_exp ( beta, a, p );
      TASK c := mod_mul ( block, k, p );
      OUTPUT el_gam_mul_next ( d, c );
  ENDDECISION;
  TASK i := i + 1;
MACRO until ( block = 0 );

STOP;


ENDPROCESS;
