/************************************************************************/
/*									*/
/*	EL_GAM\SINGLE\SEND.PRO				21.7.93		*/
/*									*/
/*	Andreas Rieke, Heusnerstr. 24, 42283 Wuppertal.			*/
/*									*/
/*	Protokoll zum Verschluesseln eines Blocks mit Hilfe des		*/
/*	ElGamal-Verschluesselungsschemas.				*/
/*									*/
/*	Vorgaben:							*/
/*	  bits:    Laenge der Schluessel in binaerer Darstellung.	*/
/*	  partner: Name des Empfaengers.				*/
/*	  message: Zu verschluesselnder Block.				*/
/*	  public:  Pfad fuer oeffentliche Schluessel.			*/
/*									*/
/************************************************************************/


PROCESS el_gam_sin_send;


DCL bits, block, c, d integer;
DCL partner charstring;
DCL message charstring;
DCL public, path charstring;
DCL p, s, beta, a, k integer;


START;

TASK bits := 512;			/* Anzahl der Bits.		*/
TASK partner := 'Andreas';		/* Maximal 8 Zeichen.		*/
TASK message := load_str ( 'f:/user/rieke/diplom/proto/secret.txt' );
TASK public := 'f:/user/rieke/diplom/keys/public';

TASK path := '/' // int2str ( bits );
TASK p    := load_int ( public // path // '/el_gam.p'    );
TASK s    := load_int ( public // path // '/el_gam.s'    );
TASK path := '/' // partner // path;
TASK beta := load_int ( public // path // '/el_gam.bet' );

TASK a := rand_max ( p );
TASK d := mod_exp ( s, a, p );
TASK k := mod_exp ( beta, a, p );
TASK block := pack ( message, 0, bits - 1 );
TASK c := mod_mul ( block, k, p );
OUTPUT el_gam_sin ( bits, d, c );

STOP;


ENDPROCESS;
