/************************************************************************/
/*									*/
/*	FIA_SHA\MEDIUM\AUTH_PAS.PRO			7.3.95		*/
/*									*/
/*	Andreas Rieke, Heusnerstr. 24, 42283 Wuppertal.			*/
/*									*/
/*	Auf Wunsch eines Anwenders kann dieser mit Hilfe dieses Fiat-	*/
/*	Shamir-Protokolls authentifiziert werden.			*/
/*									*/
/*	Vorgaben:							*/
/*	  bits_user: Laenge der Schluessel in binaerer Darstellung.	*/
/*	  anz:       Anzahl der Authentifikationsschritte.		*/
/*	  public:    Pfad fuer oeffentliche Schluessel.			*/
/*									*/
/************************************************************************/


PROCESS fia_sha_medium_auth_pas;


DCL bits_user, t, anz, n, v, ind integer;
DCL partner_id, public charstring;
DCL auth boolean;
DCL x, b, y integer;


START;

TASK bits_user := 512;
TASK anz := 20;
TASK public := 'f:/user/rieke/diplom/keys/public';

NEXTSTATE get_id;

STATE get_id;
  INPUT fia_sha_medium_id ( partner_id );
    OUTPUT fia_sha_medium_bits ( bits_user );
    NEXTSTATE get_ind;
  INPUT quit;
    NEXTSTATE get_id;
ENDSTATE;

STATE get_ind;
  INPUT fia_sha_medium_ind ( ind );
    TASK v := pack ( partner_id // int2str ( ind ) );
    TASK auth := true;
    TASK t := anz;
    TASK n := load_int ( public // '/' // int2str ( bits_user ) //
			 '/fia_sha.n' );
    OUTPUT fia_sha_next;
    NEXTSTATE fia_sha_auth_1;
ENDSTATE;

STATE auth;
  INPUT quit;
    NEXTSTATE get_id;
ENDSTATE;

STATE fia_sha_auth_1;
  INPUT fia_sha_rand ( x );
    TASK b := rand_max ( 2 );
    OUTPUT fia_sha_bit ( b );
    NEXTSTATE fia_sha_auth_2;
ENDSTATE;

STATE fia_sha_auth_2;
  INPUT fia_sha_erg ( y );
    DECISION b = 0;
      (true):
        DECISION y * y mod n /= x;
          (true):
            TASK auth := false;
        ENDDECISION;
      ELSE:
        DECISION y * y mod n /= x * v mod n;
          (true):
	    TASK auth := false;
        ENDDECISION;
    ENDDECISION;
    TASK t := t - 1;
    DECISION t = 0;
      (true):
	OUTPUT fia_sha_last;
        DECISION auth;
          (true):
            CALL writeln ( 'Fiat-Shamir-Authentifikation von ', partner_id,
			   ' mit ', bits_user, ' Bits: positiv.' );
	    NEXTSTATE auth;
    	  ELSE:
	    CALL writeln ( 'Fiat-Shamir-Authentifikation von ', partner_id,
			   ' mit ', bits_user, ' Bits: negativ.' );
	    NEXTSTATE get_id;
        ENDDECISION;
      ELSE:
	OUTPUT fia_sha_next;
        NEXTSTATE fia_sha_auth_1;
    ENDDECISION;
ENDSTATE;


ENDPROCESS;
