/************************************************************************/
/*									*/
/*	FIA_SHA\MEDIUM\KEYS\USER.PRO			7.3.95		*/
/*									*/
/*	Andreas Rieke, Heusnerstr. 24, 42283 Wuppertal.			*/
/*									*/
/*	Protokoll zum Berechnen der Anwenderschluessel fuer das		*/
/*	Fiat-Shamir-Protokoll.						*/
/*									*/
/*	Vorgaben:							*/
/*	  bits:    Laenge der Schluessel in binaerer Darstellung.	*/
/*	  user:    Name des Anwenders (Kurzform).			*/ 
/*	  id:      Name des Anwenders (Langform).			*/
/* 	  public:  Pfad fuer oeffentliche Schluessel.			*/
/*	  private: Pfad fuer geheime Anwenderschluessel.		*/
/*	  trust:   Pfad fuer Schluessel der Schluesselzentrale.		*/
/*									*/
/************************************************************************/


PROCESS fia_sha_medium_keys_user;


DCL bits, p, q, s, v, ind integer;
DCL user, id, public, private, trust, path charstring;


START;

TASK bits := 512;			
TASK user := 'Andreas';
TASK id := 'Andreas Rieke';
TASK public := 'f:/user/rieke/diplom/keys/public';
TASK private := 'f:/user/rieke/diplom/keys/private';
TASK trust := 'f:/user/rieke/diplom/keys/trust';

TASK path := '/' // int2str ( bits );
TASK p := load_int ( trust // path // '/fia_sha.p' );
TASK q := load_int ( trust // path // '/fia_sha.q' );
TASK path := '/' // user // path;
CALL mkdir ( public // path );
CALL mkdir ( private // path );

TASK ind := 0;
MACRO repeat ( a );
  TASK ind := ind + 1;
  TASK v := pack ( id // int2str ( ind ) );
MACRO until ( ( legendre ( v, p ) = 1 ) and ( legendre ( v, q ) = 1 ) );

TASK s := mod_sqrt ( v, p, q, 1 );

CALL store ( s, private // path // '/fia_sha.s' );
CALL store ( v, public // path // '/fia_sha.v' );
CALL store ( ind, public // path // '/fia_sha.ind' );
CALL store_str ( id, public // '/' // user // '/fia_sha.id' );

STOP;


ENDPROCESS;
