/************************************************************************/
/*									*/
/*	FIA_SHA\MEDIUM\USER_ACT.PRO			7.3.95		*/
/*									*/
/*	Andreas Rieke, Heusnerstr. 24, 42283 Wuppertal.			*/
/*									*/
/*	Mit Hilfe dieses Fiat - Shamir - Protokolls kann ein Anwender	*/
/*	seine Authentifikation von einem anderen Anwender anregen.	*/
/*									*/
/*	Vorgaben:							*/
/*	  user:    Name des Anwenders.					*/
/*	  public:  Pfad fuer oeffentliche Schluessel.			*/
/*	  private: Pfad fuer geheime Anwenderschluessel.		*/
/*									*/
/************************************************************************/


PROCESS fia_sha_medium_user_act;


DCL bits_partner, n, s, r, b, ind integer;
DCL id, user, public, private charstring;


START;

TASK user := 'Andreas';
TASK public := 'f:/user/rieke/diplom/keys/public';
TASK private := 'f:/user/rieke/diplom/keys/private';

TASK id := load_str ( public // '/' // user // '/' // '/fia_sha.id' );
OUTPUT fia_sha_medium_id ( id );

NEXTSTATE get_bits;


STATE get_bits;
  INPUT fia_sha_medium_bits ( bits_partner );
    TASK ind := load_int ( public // '/' // user // '/' // 
                           int2str ( bits_partner ) // '/fia_sha.ind' );
    TASK n := load_int ( public  // '/' // int2str ( bits_partner ) //
			 '/fia_sha.n' );
    TASK s := load_int ( private // '/' // user // '/' // 
			 int2str ( bits_partner ) // '/fia_sha.s' );
    OUTPUT fia_sha_medium_ind ( ind );
    NEXTSTATE fia_sha_user_1;
ENDSTATE;


STATE fia_sha_user_1;
  INPUT fia_sha_next;
    TASK r := rand_max ( n );
    OUTPUT fia_sha_rand ( r * r mod n );
    NEXTSTATE fia_sha_user_2;
  
  INPUT fia_sha_last;
    OUTPUT quit;
    STOP;
ENDSTATE;

STATE fia_sha_user_2;
  INPUT fia_sha_bit ( b );
    DECISION b = 0;
      (true): 
	OUTPUT fia_sha_erg ( r );
      ELSE:
	OUTPUT fia_sha_erg ( r * s mod n );
    ENDDECISION;
    NEXTSTATE fia_sha_user_1;
ENDSTATE;


ENDPROCESS;
