/************************************************************************/
/*									*/
/*	FIA_SHA\SIMPLE\ATTACK\AUTH_PAS.PRO		2.2.94		*/
/*									*/
/*	Andreas Rieke, Heusnerstr. 24, 42283 Wuppertal.			*/
/*									*/
/*	Dieses Fiat-Shamir-Protokoll erzeugt Ausgaben zur Auswertung	*/
/*	eines Angriffes durch einen Anwender.				*/
/*									*/
/*	Vorgaben:							*/
/*	  bits_user: Laenge der Schluessel in binaerer Darstellung.	*/
/*	  anz      : Anzahl der Authentifikationsschritte.		*/
/*	  public   : Pfad fuer oeffentliche Schluessel.			*/
/*									*/
/************************************************************************/


PROCESS fia_sha_simple_attack_auth_pas;


DCL bits_user, t, anz, n, v integer;
DCL partner, public charstring;
DCL auth boolean;
DCL x, b, y integer;


START;

TASK bits_user := 512;
TASK anz := 20;
TASK public := 'f:/user/rieke/diplom/keys/public';

NEXTSTATE ready; 


STATE ready;
  INPUT fia_sha_user ( partner );
    TASK auth := true;
    TASK t := anz;
    TASK n := load_int ( public // '/' // int2str ( bits_user ) //
			    '/fia_sha.n' );
    TASK v := load_int ( public // '/' // partner // '/' // 
			    int2str ( bits_user ) // '/fia_sha.v' );
    OUTPUT fia_sha_auth ( bits_user );
    OUTPUT fia_sha_next;
    NEXTSTATE fia_sha_auth_1;

  INPUT quit;
    NEXTSTATE ready;
ENDSTATE;

STATE fia_sha_auth_1;
  INPUT fia_sha_rand ( x );
    TASK b := rand_max ( 2 );
    OUTPUT fia_sha_bit ( b );
    NEXTSTATE fia_sha_auth_2;
ENDSTATE;

STATE fia_sha_auth_2;
  INPUT fia_sha_erg ( y );
    TASK auth := true;
    DECISION b = 0;
      (true):
        DECISION y * y mod n /= x;
          (true):
            TASK auth := false;          
        ENDDECISION;
      ELSE:
        DECISION y * y mod n /= x * v mod n;
          (true):
	    TASK auth := false;
        ENDDECISION;
    ENDDECISION;
    DECISION auth;
      (true):
        CALL writeln ( 'Schritt ', anz - t + 1, ', b = ', b, ': Ok.' );
      ELSE:
        CALL writeln ( 'Schritt ', anz - t + 1, ', b = ', b, ': Fehler.' );
    ENDDECISION;
    TASK t := t - 1;
    DECISION t = 0;
      (true):
	OUTPUT fia_sha_last;
        NEXTSTATE ready;
      ELSE:
	OUTPUT fia_sha_next;
        NEXTSTATE fia_sha_auth_1;
    ENDDECISION;
ENDSTATE;


ENDPROCESS;
