/************************************************************************/
/*									*/
/*	FIA_SHA\SIMPLE\ATTACK\USER_ACT.PRO		1.2.94		*/
/*									*/
/*	Andreas Rieke, Heusnerstr. 24, 42283 Wuppertal.			*/
/*									*/
/*	Mit Hilfe dieses Protokolls kann ein Anwender einen Angriff	*/
/*	auf das Fiat-Shamir-Protokoll versuchen.			*/
/*									*/
/*	Vorgaben:							*/
/*	  user   : Name des Anwenders.					*/
/*	  public : Pfad fuer oeffentliche Schluessel.			*/
/*	  private: Pfad fuer geheime Anwenderschluessel.		*/
/*									*/
/************************************************************************/


PROCESS fia_sha_simple_attack_user_act;


DCL bits_partner, x, n, v, r, b_user, b_partner, t integer;
DCL user, public, private charstring;


START;

TASK user := 'Andreas';
TASK public := 'f:/user/rieke/diplom/keys/public';
TASK t := 0;

OUTPUT fia_sha_user ( user );

NEXTSTATE ready;


STATE ready;
  INPUT fia_sha_auth ( bits_partner );
    TASK n := load_int ( public // '/' // int2str ( bits_partner ) //
			    '/fia_sha.n' );
    TASK v := load_int ( public // '/' // user // '/' // 
			    int2str ( bits_partner ) // '/fia_sha.v' );
    NEXTSTATE fia_sha_user_1;
ENDSTATE;

STATE fia_sha_user_1;
  INPUT fia_sha_next;
    TASK r := rand_max ( n );
    TASK b_user := rand_max ( 2 );
    DECISION b_user = 0;
      (true):
        TASK x := r * r mod n;
      ELSE:
        TASK x := r * r * rcp ( v, n ) mod n;
    ENDDECISION;
    OUTPUT fia_sha_rand ( x );
    NEXTSTATE fia_sha_user_2;
  
  INPUT fia_sha_last;
    OUTPUT quit;
    STOP;
ENDSTATE;

STATE fia_sha_user_2;
  INPUT fia_sha_bit ( b_partner );
    TASK t := t + 1;
    CALL writeln ( 'Schritt ', t, ', erwartet: ', b_user, ', gefordert: ', b_partner );
    OUTPUT fia_sha_erg ( r );
    NEXTSTATE fia_sha_user_1;
ENDSTATE;


ENDPROCESS;
