/************************************************************************/
/*									*/
/*	FIA_SHA\SIMPLE\AUTH_ACT.PRO			21.7.93		*/
/*									*/
/*	Andreas Rieke, Heusnerstr. 24, 42283 Wuppertal.			*/
/*									*/
/*	Dieses Protokoll initiiert die Authentifikation des Partners.	*/
/*									*/
/*	Vorgaben:							*/
/*	  bits_user: Laenge der Schluessel, mit denen die Authentifi-	*/
/*		     kation durchgefuehrt wird.				*/
/*	  partner:   Name des Partners.					*/
/*	  public:    Pfad fuer oeffentliche Schluessel.			*/
/*	  anz:       Anzahl der Authentifikationsschritte.		*/
/*									*/
/************************************************************************/


PROCESS fia_sha_simple_auth_act;


DCL bits_user, anz, n, v integer;
DCL partner, public charstring;
DCL auth boolean;
DCL x, b, y integer;


START;

TASK bits_user := 512;
TASK partner := 'Andreas';
TASK anz := 20;
TASK public := 'f:/user/rieke/diplom/keys/public';

TASK n := load_int ( public // '/' // int2str ( bits_user ) //
			'/fia_sha.n' );
TASK v := load_int ( public // '/' // partner // '/' // 
			int2str ( bits_user ) // '/fia_sha.v' );

TASK auth := true;
OUTPUT fia_sha_auth ( bits_user );
OUTPUT fia_sha_next;

NEXTSTATE fia_sha_auth_1;


STATE ready;
  INPUT quit;
    STOP;
ENDSTATE;

STATE auth;
  INPUT quit;
    STOP;
ENDSTATE;

STATE fia_sha_auth_1;
  INPUT fia_sha_rand ( x );
    TASK b := rand_max ( 2 );
    OUTPUT fia_sha_bit ( b );
    NEXTSTATE fia_sha_auth_2;
ENDSTATE;

STATE fia_sha_auth_2;
  INPUT fia_sha_erg ( y );
    DECISION b = 0;
      (true):
        DECISION y * y mod n /= x;
          (true):
            TASK auth := false;
        ENDDECISION;
      ELSE:
        DECISION y * y mod n /= x * v mod n;
          (true):
	    TASK auth := false;
        ENDDECISION;
    ENDDECISION;
    TASK anz := anz - 1;
    DECISION anz = 0;
      (true):
	OUTPUT fia_sha_last;
        DECISION auth;
          (true):
            CALL writeln ( 'Fiat-Shamir-Authentifikation von ', partner,
			   ' mit ', bits_user, ' Bits: positiv.' );
	    NEXTSTATE auth;
    	  ELSE:
	    CALL writeln ( 'Fiat-Shamir-Authentifikation von ', partner,
			   ' mit ', bits_user, ' Bits: negativ.' );
	    NEXTSTATE ready;
        ENDDECISION;
      ELSE:
	OUTPUT fia_sha_next;
	NEXTSTATE fia_sha_auth_1;
    ENDDECISION;
ENDSTATE;


ENDPROCESS;
