/************************************************************************/
/*									*/
/*	FIA_SHA\SIMPLE\KEYS\COMMON.PRO			21.7.93		*/
/*									*/
/*	Andreas Rieke, Heusnerstr. 24, 42283 Wuppertal.			*/
/*									*/
/*	Berechnet den gemeinsamen Schluessel fuer das Fiat - Shamir -	*/
/*	Protokoll.							*/
/*									*/
/*	Vorgaben:							*/
/*	  bits:   Laenge des Schluessels in binaerer Darstellung.	*/
/*	  public: Pfad fuer oeffentliche Schluessel.			*/
/*	  trust:  Pfad fuer geheime Schluessel der Schluesselzentrale.	*/ 
/*									*/
/*	Sonstiges:							*/
/*	  Dieses Protokoll erzeugt Schluessel, die nur fuer die 	*/
/*	  SIMPLE-Version benutzt werden koennen.			*/
/*									*/
/************************************************************************/


PROCESS fia_sha_simple_keys_common;


DCL bits, p, q, n integer;		
DCL public, trust, path charstring;


START;

TASK bits := 512;			
TASK public := 'f:/user/rieke/diplom/keys/public';		
TASK trust :=  'f:/user/rieke/diplom/keys/trust';		
	
TASK path := '/' // int2str ( bits );
CALL mkdir ( public // path );		/* Fuer vorgegebene Stellenzahl.*/
CALL mkdir ( trust  // path );

TASK p := rand_bits_prime ( bits / 2 );
TASK q := rand_bits_prime ( bits / 2 );

TASK n := p * q;	

CALL store ( p, trust  // path // '/fia_sha.p' );
CALL store ( q, trust  // path // '/fia_sha.q' );
CALL store ( n, public // path // '/fia_sha.n' );

STOP;


ENDPROCESS;
