/************************************************************************/
/*									*/
/*	FIA_SHA\SIMPLE\KEYS\USER.PRO			21.7.93		*/
/*									*/
/*	Andreas Rieke, Heusnerstr. 24, 42283 Wuppertal.			*/
/*									*/
/*	Protokoll zum Berechnen der Anwenderschluessel fuer das		*/
/*	Fiat - Shamir - Protokoll.					*/
/*									*/
/*	Vorgaben:							*/
/*	  bits:    Laenge der Schluessel in binaerer Darstellung.	*/
/*	  user:    Name des Anwenders.					*/ 
/* 	  public:  Pfad fuer oeffentliche Schluessel.			*/
/*	  private: Pfad fuer geheime Anwenderschluessel.		*/
/*									*/
/*	Sonstiges:							*/
/*	  Dieses Protokoll erzeugt Schluessel, die nur fuer die 	*/
/*	  SIMPLE-Version benutzt werden koennen.			*/
/*									*/
/************************************************************************/


PROCESS fia_sha_simple_keys_user;


DCL bits, n, s, v integer;
DCL user, public, private, path charstring;


START;

TASK bits := 512;			
TASK user := 'Andreas';
TASK public := 'f:/user/rieke/diplom/keys/public';
TASK private := 'f:/user/rieke/diplom/keys/private';

TASK path := '/' // int2str ( bits );
TASK n := load_int ( public // path // '/fia_sha.n' );
TASK path := '/' // user // path;
CALL mkdir ( public  // path );
CALL mkdir ( private // path );

TASK s := rand_max ( n );		/* Zufallszahl berechnen.	*/
TASK v := mod_mul ( s, s, n );	/* und quadrieren.		*/

CALL store ( s, private // path // '/fia_sha.s' );
CALL store ( v, public  // path // '/fia_sha.v' );

STOP;


ENDPROCESS;
