/************************************************************************/
/*									*/
/*	FIA_SHA\SIMPLE\USER_ACT.PRO			21.7.93		*/
/*									*/
/*	Andreas Rieke, Heusnerstr. 24, 42283 Wuppertal.			*/
/*									*/
/*	Mit Hilfe dieses Fiat-Shamir-Protokolls kann ein Anwender	*/
/*	seine Authentifikation von einem anderen Anwender anregen.	*/
/*									*/
/*	Vorgaben:							*/
/*	  user:    Name des Anwenders.					*/
/*	  public:  Pfad fuer oeffentliche Schluessel.			*/
/*	  private: Pfad fuer geheime Anwenderschluessel.		*/
/*									*/
/************************************************************************/


PROCESS fia_sha_simple_user_act;


DCL bits_partner, n, s, r, b integer;
DCL user, public, private charstring;


START;

TASK user := 'Andreas';
TASK public := 'f:/user/rieke/diplom/keys/public';
TASK private := 'f:/user/rieke/diplom/keys/private';

OUTPUT fia_sha_user ( user );

NEXTSTATE ready;


STATE ready;
  INPUT fia_sha_auth ( bits_partner );
    TASK n := load_int ( public  // '/' // int2str ( bits_partner ) //
			    '/fia_sha.n' );
    TASK s := load_int ( private // '/' // user // '/' // 
			    int2str ( bits_partner ) // '/fia_sha.s' );
    NEXTSTATE fia_sha_user_1;
ENDSTATE;

STATE fia_sha_user_1;
  INPUT fia_sha_next;
    TASK r := rand_max ( n );
    OUTPUT fia_sha_rand ( r * r mod n );
    NEXTSTATE fia_sha_user_2;
  
  INPUT fia_sha_last;
    OUTPUT quit;
    STOP;
ENDSTATE;

STATE fia_sha_user_2;
  INPUT fia_sha_bit ( b );
    DECISION b = 0;
      (true): 
	OUTPUT fia_sha_erg ( r );
      ELSE:
	OUTPUT fia_sha_erg ( r * s mod n );
    ENDDECISION;
    NEXTSTATE fia_sha_user_1;
ENDSTATE;


ENDPROCESS;
