/************************************************************************/
/*									*/
/*	GUI_QUI\KEYS\COMMON.PRO				19.11.94	*/
/*									*/
/*	Andreas Rieke, Heusnerstr. 24, 42283 Wuppertal.			*/
/*									*/
/*	Berechnet die gemeinsamen Schluessel fuer das 			*/
/*	Guillou-Quisquater-Protokoll.					*/
/*									*/
/*	Vorgaben:							*/
/*	  bits:   Laenge des Schluessels in binaerer Darstellung.	*/
/*	  vmax:   Obere Grenze fuer den oeffentlichen Schluessel v.	*/
/*	  public: Pfad fuer oeffentliche Schluessel.			*/
/*	  trust:  Pfad fuer geheime Schluessel der Schluesselzentrale.	*/
/*									*/
/************************************************************************/


PROCESS gui_qui_keys_common;


DCL bits, vmax, p, q, n, t, v integer;		
DCL public, trust, path charstring;


START;

TASK bits := 512;
TASK vmax := exp ( 2, 30 );		
TASK public := 'f:/user/rieke/diplom/keys/public';		
TASK trust :=  'f:/user/rieke/diplom/keys/trust';
	
TASK path := '/' // int2str ( bits );
CALL mkdir ( public // path );		/* Fuer vorgegebene Stellenzahl.*/
CALL mkdir ( trust  // path );

TASK p := rand_bits_prime ( bits / 2 );
TASK q := rand_bits_prime ( bits / 2 );

TASK n := p * q;
TASK t := ( p - 1 ) * ( q - 1 );

TASK v := rand_max ( min ( vmax, t ) );

CALL store ( p, trust  // path // '/gui_qui.p' );
CALL store ( q, trust  // path // '/gui_qui.q' );
CALL store ( n, public // path // '/gui_qui.n' );
CALL store ( v, public // path // '/gui_qui.v' );

STOP;


ENDPROCESS;
