/************************************************************************/
/*									*/
/*	GUI_QUI\KEYS\USER.PRO				19.11.94	*/
/*									*/
/*	Andreas Rieke, Heusnerstr. 24, 42283 Wuppertal.			*/
/*									*/
/*	Protokoll zum Berechnen der Anwenderschluessel fuer das		*/
/*	Guillou-Quisquater-Protokoll.					*/
/*									*/
/*	Vorgaben:							*/
/*	  bits:    Laenge der Schluessel in binaerer Darstellung.	*/
/*	  user:    Name des Anwenders.					*/ 
/* 	  public:  Pfad fuer oeffentliche Schluessel.			*/
/*	  private: Pfad fuer geheime Anwenderschluessel.		*/
/*									*/
/************************************************************************/


PROCESS gui_qui_keys_user;


DCL bits, n, v, j, a, b integer;
DCL user, public, private, path charstring;


START;

TASK bits := 512;			
TASK user := 'Andreas';
TASK public := 'f:/user/rieke/diplom/keys/public';
TASK private := 'f:/user/rieke/diplom/keys/private';

TASK path := '/' // int2str ( bits );
TASK n := load_int ( public // path // '/gui_qui.n' );
TASK v := load_int ( public // path // '/gui_qui.v' );
TASK path := '/' // user // path;
CALL mkdir ( public  // path );
CALL mkdir ( private // path );

MACRO repeat ( loop );
  TASK b := rand_max ( n );
MACRO until ( gcd ( b, n ) = 1 );
TASK a := rcp ( b, n );
TASK j := mod_exp ( a, v, n );

CALL store ( b, private // path // '/gui_qui.b' );
CALL store ( j, public  // path // '/gui_qui.j' );

STOP;


ENDPROCESS;
