/************************************************************************/
/*									*/
/*	MAS_OMU\KEYS\COMMON.PRO				21.7.93		*/
/*									*/
/*	Andreas Rieke, Heusnerstr. 24, 42283 Wuppertal.			*/
/*									*/
/*	Protokoll zum Erzeugen der gemeinsamen Schluessel fuer das 	*/
/*	Massey - Omura - Schema.					*/
/*									*/
/*	Vorgaben:							*/
/*	  bits:   Laenge der Schluessel in binaerer Darstellung.	*/
/*	  public: Pfad fuer oeffentliche Schluessel.			*/
/*									*/
/************************************************************************/


PROCESS mas_omu_keys_common;


DCL bits, p integer;
DCL public, path charstring;


START;

TASK bits := 512;			/* Anzahl der Bits.		*/

TASK public := 'f:/user/rieke/diplom/keys/public';	
					/* Fuer oeffentliche Schluessel.*/
TASK path := '/' // int2str ( bits );
CALL mkdir ( public // path );

TASK p := rand_bits_prime ( bits );	/* Primzahl berechnen.		*/

CALL store ( p, public // path // '/mas_omu.prm' );

STOP;


ENDPROCESS;
