/************************************************************************/
/*									*/
/*	MAS_OMU\KEYS\USER.PRO				21.7.93		*/
/*									*/
/*	Andreas Rieke, Heusnerstr. 24, 42283 Wuppertal.			*/
/*									*/
/*	Protokoll zum Erzeugen der Anwenderschluessel fuer das		*/
/*	Massey - Omura - Schema.					*/
/*									*/
/*	Vorgaben:							*/
/*	  bits:    Laenge der Schluessel in binaerer Darstellung.	*/
/*	  user:    Name des Anwenders.					*/
/*	  public:  Pfad fuer oeffentliche Schluessel.			*/
/*	  private: Pfad fuer geheime Anwenderschluessel.		*/
/*									*/
/************************************************************************/


PROCESS mas_omu_keys_user;


DCL bits integer;
DCL user charstring;
DCL public, private, path charstring;
DCL p, t, e, d integer;


START;

TASK bits := 512;			/* Anzahl der Bits.		*/
TASK user := 'Andreas';		/* Maximal 8 Zeichen.		*/

TASK public := 'f:/user/rieke/diplom/keys/public';
					/* Fuer oeffentliche Schluessel.*/
TASK private := 'f:/user/rieke/diplom/keys/private';	
					/* Fuer private Schluessel.	*/

TASK path := '/' // user // '/' // int2str ( bits );
CALL mkdir ( private // path );	/* Fuer geheime Schluessel.	*/

TASK p := load_int ( public // '/' // int2str ( bits ) //
			'/mas_omu.prm' );

TASK t := p - 1;			/* Anzahl teilerfremde Zahlen.	*/

MACRO repeat ( a ); 
  TASK e := rand_max ( t );		/* Zufallszahl kleiner t.	*/
MACRO until ( gcd ( e, t ) = 1 );	/* e muss teilerfr. zu t sein.  */

TASK d := rcp ( e, t );		/* Modularer Kehrwert.		*/

CALL store ( e, private // path // '/mas_omu.e' );
CALL store ( d, private // path // '/mas_omu.d' );

STOP;


ENDPROCESS;
