/************************************************************************/
/*									*/
/*	MAS_OMU\MULTIPLE\RECEIVE.PRO			21.7.93		*/
/*									*/
/*	Andreas Rieke, Heusnerstr. 24, 42283 Wuppertal.			*/
/*									*/
/*	Protokoll zum Empfangen einer mit Hilfe des Massey - Omura -	*/
/*	Schemas uebertragenen Nachricht.				*/
/*									*/
/*	Vorgaben:							*/
/*	  user:    Name des Anwenders.					*/
/*	  public:  Pfad fuer oeffentliche Schluessel.			*/
/*	  private: Pfad fuer geheime Anwenderschluessel.		*/
/*									*/
/************************************************************************/


PROCESS mas_omu_mul_receive;


DCL user charstring;
DCL bits_partner integer;
DCL public, private, path charstring;
DCL p, e, d, wert integer;
DCL message charstring;


START;

TASK user := 'Kirsten';
TASK public := 'f:/user/rieke/diplom/keys/public';
TASK private := 'f:/user/rieke/diplom/keys/private';

NEXTSTATE ready;


STATE ready;
  INPUT mas_omu_mul ( bits_partner );
    TASK message := '';
    TASK p := load_int ( public // '/' // int2str ( bits_partner ) //
			    '/mas_omu.prm' );
    TASK path := '/' // user // '/' // int2str ( bits_partner );
    TASK e := load_int ( private // path // '/mas_omu.e' );
    TASK d := load_int ( private // path // '/mas_omu.d' );
    NEXTSTATE mas_omu_mul;
ENDSTATE;

STATE mas_omu_mul;
  INPUT mas_omu_mul_next ( wert );
    TASK wert := mod_exp ( wert, e, p );
    OUTPUT mas_omu_mul_a ( wert );
    NEXTSTATE mas_omu_mul_2;
  INPUT mas_omu_mul_last;
    CALL writeln ( 'Massey-Omura-Mehrfachuebertragung mit ', 
		   bits_partner, ' Bits:' );
    CALL writeln ( '  ', message );
    NEXTSTATE ready;
ENDSTATE;

STATE mas_omu_mul_2;
  INPUT mas_omu_mul_b ( wert );
    TASK wert := mod_exp ( wert, d, p );
    TASK message := message // unpack ( wert );
    NEXTSTATE mas_omu_mul;
ENDSTATE;


ENDPROCESS;
