/************************************************************************/
/*									*/
/*	MAS_OMU\MULTIPLE\SEND.PRO			21.7.93		*/
/*									*/
/*	Andreas Rieke, Heusnerstr. 24, 42283 Wuppertal.			*/
/*									*/
/*	Protokoll zum Versenden einer Nachricht mit Hilfe des Massey-	*/
/*	Omura-Schemas.							*/
/*									*/
/*	Vorgaben:							*/
/*	  user:    Name des Anwenders.					*/
/*	  bits:    Laenge der Schluessel in binaerer Darstellung.	*/
/*	  message: Zu versendende Nachricht.				*/
/*	  public:  Pfad fuer oeffentliche Schluessel.			*/
/*	  private: Pfad fuer geheime Anwenderschluessel.		*/
/*									*/
/************************************************************************/


PROCESS mas_omu_mul_send;


DCL user charstring;
DCL bits integer;
DCL message charstring;
DCL public, private, path charstring;
DCL p, e, d, i, wert integer;


START;

TASK user := 'Andreas';
TASK bits := 512;			/* Anzahl der Bits.		*/
TASK message := load_str ( 'f:/user/rieke/diplom/proto/secret.txt' );

TASK public := 'f:/user/rieke/diplom/keys/public/';
TASK private := 'f:/user/rieke/diplom/keys/private/';

TASK p := load_int ( public // int2str ( bits ) // '/mas_omu.prm' );
TASK path := user // '/' // int2str ( bits );
TASK e := load_int ( private // path // '/mas_omu.e' );
TASK d := load_int ( private // path // '/mas_omu.d' );

OUTPUT mas_omu_mul ( bits );
TASK wert := pack ( message, 0, bits - 2 );
TASK wert := mod_exp ( wert, e, p );
OUTPUT mas_omu_mul_next ( wert );
NEXTSTATE mas_omu_mul_1;


STATE mas_omu_mul_1;
  INPUT mas_omu_mul_a ( wert );
    TASK wert := mod_exp ( wert, d, p );
    OUTPUT mas_omu_mul_b ( wert );
    TASK i := i + 1;
    TASK wert := pack ( message, i, bits - 2 );
    DECISION wert = 0;
      (true):
        OUTPUT mas_omu_mul_last;
	STOP;
      ELSE:
        TASK wert := mod_exp ( wert, e, p );
        OUTPUT mas_omu_mul_next ( wert );
        NEXTSTATE mas_omu_mul_1;
    ENDDECISION;
ENDSTATE;


ENDPROCESS;
