/************************************************************************/
/*									*/
/*	MAS_OMU\SINGLE\RECEIVE.PRO			21.7.93		*/
/*									*/
/*	Andreas Rieke, Heusnerstr. 24, 42283 Wuppertal.			*/
/*									*/
/*	Protokoll zum Empfangen eines mit Hilfe des Massey - Omura -	*/
/*	Schemas uebertragenen Blocks.   				*/
/*									*/
/*	Vorgaben:							*/
/*	  user:    Name des Anwenders.					*/
/*	  public:  Pfad fuer oeffentliche Schluessel.			*/
/*	  private: Pfad fuer geheime Anwenderschluessel.		*/
/*									*/
/************************************************************************/


PROCESS mas_omu_sin_receive;


DCL user, message charstring;
DCL bits_partner integer;
DCL public, private, path charstring;
DCL p, e, d, wert integer;


START;

TASK user := 'Andreas';
TASK public := 'f:/user/rieke/diplom/keys/public';
TASK private := 'f:/user/rieke/diplom/keys/private';

NEXTSTATE ready;


STATE ready;
  INPUT mas_omu_sin ( bits_partner, wert );
    TASK p := load_int ( public // '/' // int2str ( bits_partner ) //
			    '/mas_omu.prm' );
    TASK path := '/' // user // '/' // int2str ( bits_partner );
    TASK e := load_int ( private // path // '/mas_omu.e' );
    TASK d := load_int ( private // path // '/mas_omu.d' );
    TASK wert := mod_exp ( wert, e, p );
    OUTPUT mas_omu_sin_b ( wert );
    NEXTSTATE mas_omu_sin_2;
ENDSTATE;

STATE mas_omu_sin_2;
  INPUT mas_omu_sin_c ( wert );
    TASK wert := mod_exp ( wert, d, p );
    TASK message := unpack ( wert );
    CALL writeln ( 'Massey - Omura - Einfachuebertragung mit ', 
		   bits_partner, ' Bits:' );
    CALL writeln ( '  ', message );
    NEXTSTATE ready;
ENDSTATE;


ENDPROCESS;
