/************************************************************************/
/*									*/
/*	MATH\SQRT\FAST_PQ.PRO				24. 2. 95	*/
/*									*/
/*	Andreas Rieke, Heusnerstr. 24, 42283 Wuppertal.			*/
/*									*/
/*	Protokoll zum modularen Quadratwurzelziehen.			*/
/*	( r * r ) mod ( p * q ) = a					*/
/*									*/
/*	Vorgaben:							*/
/*	  p: mu eine ungerade Primzahl sein.				*/
/*	  q: mu eine ungerade Primzahl sein, q /= p.			*/
/*	  a: Quadrat. 0 < a < ( p * q ).				*/
/*									*/
/************************************************************************/


PROCESS sqrt_fast_pq;


DCL p, q, a integer;
DCL n, sqrt_p, sqrt_q, sqrt_n integer;
DCL l, m, c, d integer;


START;

TASK p := 36013;
TASK q := 47093;
TASK a := 27412;


/* Wurzeln mit 2 * Index 1 oder 2 * Index 2:					*/
/*	1093142146							*/
/*	602818063							*/

/* Wurzeln mit 1 * Index 1 und 1 * Index 2:						*/
/*	324113456							*/
/*	1371846753							*/


TASK n := p * q;

DECISION p = q;
  (true):
    CALL writeln ( Fehler: 'p = q.' );
    STOP;
  ELSE:
    DECISION p > q;			/* Es muss immer q > p gelten.	*/
      (true):
        TASK l := q;
        TASK q := p;
        TASK p := l;
    ENDDECISION;
    TASK sqrt_p := mod_sqrt ( a, p, 1 );
    TASK sqrt_q := mod_sqrt ( a, q, 1 );
    TASK l := rcp ( p, q );
    TASK m := ( l * p - 1 ) / q;	/* m ist negativ.		*/
    TASK c := m * q;			/* c ist negativ.		*/
    TASK d := l * p;
    TASK sqrt_n := ( n * n - c * sqrt_p + d * sqrt_q ) mod n;
ENDDECISION;

DECISION sqrt_n * sqrt_n mod n = a;
  (true):
    CALL writeln ( sqrt_n, ' * ', sqrt_n, ' mod ', n, ' = ', a );
    TASK sqrt_n := n - sqrt_n;
    DECISION sqrt_n * sqrt_n mod n = a;
      (true):
        CALL writeln ( sqrt_n, ' * ', sqrt_n, ' mod ', n, ' = ', a );
      ELSE:
        CALL writeln ( 'Fehler 2 !' );
    ENDDECISION;
  ELSE:
    CALL writeln ( 'Fehler 3 !' );
ENDDECISION;

    
STOP;

ENDPROCESS;
