/************************************************************************/
/*									*/
/*	RSA\KEYS\RSA_110.PRO				21.7.93		*/
/*									*/
/*	Andreas Rieke, Heusnerstr. 24, 42283 Wuppertal.			*/
/*									*/
/*	Protokoll zum Berechnen der Schluessel fuer RSA-110.		*/
/*									*/
/*	Vorgaben:							*/
/*	  public:  Pfad fuer oeffentliche Schluessel.			*/
/*	  private: Pfad fuer geheime Anwenderschluessel.		*/
/*									*/
/************************************************************************/


PROCESS rsa_keys_rsa_110;


DCL user, path charstring;		/* Name des Anwenders.		*/
DCL bits integer;			/* Laenge des Primzahlprodukts.	*/			 
DCL public, private charstring;
DCL p, q, n, t, e, d integer;


START;

TASK user := 'rsa';			/* Maximal 8 Zeichen.		*/
TASK bits := 364;			/* Anzahl der Bits.		*/
TASK public := 'f:/user/rieke/diplom/keys/public';
TASK private := 'f:/user/rieke/diplom/keys/private';

TASK path := '/' // user // '/' // int2str ( bits );
CALL mkdir ( public  // path );	/* Fuer diesen Anwender.	*/
CALL mkdir ( private // path );

TASK p := 5846418214406154678836553182979162384198610505601062333;
TASK q := 6122421090493547576937037317561418841225758554253106999;
TASK n := 35794234179725868774991807832568455403003778024228226193532908190484670252364677411513516111204504060317568667;

DECISION n /= p * q;
  (true):
    CALL writeln ( 'Zahlen falsch eingegeben!' );
    STOP;
ENDDECISION;

TASK t := ( p - 1 ) * ( q - 1 );	/* Anzahl teilerfremde Zahlen.	*/

TASK e := 9007;			/* Oeffentlicher Schluessel.	*/

TASK d := rcp ( e, t );		/* Modularer Kehrwert.		*/

CALL store ( n, public  // path // '/rsa.n' );
CALL store ( e, public  // path // '/rsa.e' );
CALL store ( d, private // path // '/rsa.d' );

STOP;


ENDPROCESS;
