/************************************************************************/
/*									*/
/*	RSA\KEYS\RSA_120.PRO				21.7.93		*/
/*									*/
/*	Andreas Rieke, Heusnerstr. 24, 42283 Wuppertal.			*/
/*									*/
/*	Protokoll zum Berechnen der Schluessel fuer RSA-120.		*/
/*									*/
/*	Vorgaben:							*/
/*	  public:  Pfad fuer oeffentliche Schluessel.			*/
/*	  private: Pfad fuer geheime Anwenderschluessel.		*/
/*									*/
/************************************************************************/


PROCESS rsa_keys_rsa_120;


DCL user, path charstring;		/* Name des Anwenders.		*/
DCL bits integer;			/* Laenge des Primzahlprodukts.	*/			 
DCL public, private charstring;
DCL p, q, n, t, e, d integer;


START;

TASK user := 'rsa';			/* Maximal 8 Zeichen.		*/
TASK bits := 397;			/* Anzahl der Bits.		*/
TASK public := 'f:/user/rieke/diplom/keys/public';
TASK private := 'f:/user/rieke/diplom/keys/private';

TASK path := '/' // user // '/' // int2str ( bits );
CALL mkdir ( public  // path );	/* Fuer diesen Anwender.	*/
CALL mkdir ( private // path );

TASK p := 327414555693498015751146303749141488063642403240171463406883;
TASK q := 693342667110830181197325401899700641361965863127336680673013;
TASK n := 227010481295437363334259960947493668895875336466084780038173258247009162675779735389791151574049166747880487470296548479;

DECISION n /= p * q;
  (true):
    CALL writeln ( 'Zahlen falsch eingegeben!' );
    STOP;
ENDDECISION;

TASK t := ( p - 1 ) * ( q - 1 );	/* Anzahl teilerfremde Zahlen.	*/

TASK e := 9007;			/* Oeffentlicher Schluessel.	*/

TASK d := rcp ( e, t );		/* Modularer Kehrwert.		*/

CALL store ( n, public  // path // '/rsa.n' );
CALL store ( e, public  // path // '/rsa.e' );
CALL store ( d, private // path // '/rsa.d' );

STOP;


ENDPROCESS;
