/************************************************************************/
/*									*/
/*	RSA\KEYS\RSA_129.PRO				21.7.93		*/
/*									*/
/*	Andreas Rieke, Heusnerstr. 24, 42283 Wuppertal.			*/
/*									*/
/*	Protokoll zum Berechnen der Schluessel fuer RSA-129.		*/
/*									*/
/*	Vorgaben:							*/
/*	  public:  Pfad fuer oeffentliche Schluessel.			*/
/*	  private: Pfad fuer geheime Anwenderschluessel.		*/
/*									*/
/************************************************************************/


PROCESS rsa_129;


DCL user, path charstring;		/* Name des Anwenders.		*/
DCL bits integer;			/* Laenge des Primzahlprodukts.	*/			 
DCL public, private charstring;
DCL p, q, n, t, e, d integer;


START;

TASK user := 'rsa';			/* Maximal 8 Zeichen.		*/
TASK bits := 426;			/* Anzahl der Bits.		*/
TASK public := 'f:/user/rieke/diplom/keys/public';
TASK private := 'f:/user/rieke/diplom/keys/private';

TASK path := '/' // user // '/' // int2str ( bits );
CALL mkdir ( public  // path );	/* Fuer diesen Anwender.	*/
CALL mkdir ( private // path );

TASK p := 3490529510847650949147849619903898133417764638493387843990820577;
TASK q := 32769132993266709549961988190834461413177642967992942539798288533;
TASK n := 114381625757888867669235779976146612010218296721242362562561842935706935245733897830597123563958705058989075147599290026879543541;

DECISION n /= p * q;
  (true):
    CALL writeln ( 'Zahlen falsch eingegeben!' );
    STOP;
ENDDECISION;

TASK t := ( p - 1 ) * ( q - 1 );	/* Anzahl teilerfremde Zahlen.	*/

TASK e := 9007;			/* Oeffentlicher Schluessel.	*/

TASK d := rcp ( e, t );		/* Modularer Kehrwert.		*/
	
CALL store ( n, public  // path // '/rsa.n' );
CALL store ( e, public  // path // '/rsa.e' );
CALL store ( d, private // path // '/rsa.d' );

STOP;


ENDPROCESS;
