/************************************************************************/
/*									*/
/*	RSA\KEYS\USER.PRO				21.7.93		*/
/*									*/
/*	Andreas Rieke, Heusnerstr. 24, 42283 Wuppertal.			*/
/*									*/
/*	Protokoll zum Berechnen der Anwenderschluessel fuer das RSA -	*/
/*	Verfahren.							*/
/*									*/
/*	Vorgaben:							*/
/*	  user:    Name des Anwenders.					*/
/*	  bits:    Laenge der Schluessel in binaerer Darstellung.	*/
/*	  public:  Pfad fuer oeffentliche Schluessel.			*/
/*	  private: Pfad fuer geheime Anwenderschluessel.		*/
/*									*/
/************************************************************************/


PROCESS rsa_keys_user;


DCL user, path charstring;		/* Name des Anwenders.		*/
DCL bits integer;			/* Laenge des Primzahlprodukts.	*/			 
DCL public, private charstring;
DCL p, q, n, t, e, d integer;


START;

TASK user := 'Andreas';		/* Maximal 8 Zeichen.		*/
TASK bits := 512;			/* Anzahl der Bits.		*/
TASK public := 'f:/user/rieke/diplom/keys/public';
TASK private := 'f:/user/rieke/diplom/keys/private';

TASK path := '/' // user // '/' // int2str ( bits );
CALL mkdir ( public  // path );	/* Fuer diesen Anwender.	*/
CALL mkdir ( private // path );

TASK p := rand_bits_prime ( bits / 2 );	
MACRO repeat ( a );
  TASK q := rand_bits_prime ( bits / 2 );
MACRO until ( p /= q );			/* p /= q 			*/

TASK n := p * q;	
TASK t := ( p - 1 ) * ( q - 1 );	/* Anzahl teilerfremde Zahlen.	*/

MACRO repeat ( b ); 
  TASK e := rand_max ( t );		/* Zufallszahl kleiner t.	*/
MACRO until ( gcd ( e, t ) = 1 );	/* e muss teilerfr. zu t sein.  */

TASK d := rcp ( e, t );		/* Modularer Kehrwert.		*/
	
CALL store ( n, public  // path // '/rsa.n' );
CALL store ( e, public  // path // '/rsa.e' );
CALL store ( d, private // path // '/rsa.d' );

STOP;


ENDPROCESS;
