/************************************************************************/
/*									*/
/*	RSA\MULTIPLE\512\RECEIVE.PRO			28.1.94		*/
/*									*/
/*	Andreas Rieke, Heusnerstr. 24, 42283 Wuppertal.			*/
/*									*/
/*	Protokoll zum Entschluesseln einer mit Hilfe des RSA- 		*/
/*	Verfahrens verschluesselten Nachricht.				*/
/*									*/
/*	Vorgaben:							*/
/*	  public:  Pfad fuer oeffentliche Schluessel.			*/
/*	  private: Pfad fuer geheime Anwenderschluessel.		*/
/*									*/
/************************************************************************/


PROCESS rsa_mul_receive_512;


DCL public, private charstring;		/* Pfade zu den Schluesseln	*/
DCL n, d integer;			/* RSA-Schluessel		*/
DCL block integer;			/* Hilfsvariable		*/
DCL message charstring;		/* Empfangene Nachricht		*/


START;

TASK public := 'f:/user/rieke/diplom/keys/public';		
					/* Fuer oeffentliche Schluessel	*/
TASK private := 'f:/user/rieke/diplom/keys/private';		
					/* Fuer geheime Schluessel	*/

NEXTSTATE ready;


STATE ready;
  INPUT rsa_mul_512 ( );
    TASK n := load_int ( public  // '/512/rsa.n' );
    TASK d := load_int ( private // '/512/rsa.d' );
    TASK message := '';
    NEXTSTATE rsa_mul;
ENDSTATE;

STATE rsa_mul;
  INPUT rsa_mul_next ( block );
    TASK message := message // unpack ( mod_exp ( block, d, n ) );
    NEXTSTATE rsa_mul;

  INPUT rsa_mul_last;
    CALL writeln ( 'RSA-Uebertragung:' );
    CALL writeln ( '  ', message );
    NEXTSTATE ready;
ENDSTATE;


ENDPROCESS;
