/************************************************************************/
/*									*/
/*	RSA\MULTIPLE\512\SEND.PRO			28.1.94		*/
/*									*/
/*	Andreas Rieke, Heusnerstr. 24, 42283 Wuppertal.			*/
/*									*/
/*	Protokoll zum Verschluesseln einer Nachricht nach dem RSA-	*/
/*	Verfahren mit 512 Bits.						*/
/*									*/
/*	Vorgaben:							*/
/* 	  public: Pfad fuer oeffentliche Schluessel.			*/
/*									*/
/************************************************************************/


PROCESS rsa_mul_send_512;


DCL public charstring;			/* Pfad zu den Schluesseln	*/
DCL n, e integer;			/* RSA-Schluessel		*/
DCL i, block integer;			/* Hilfsvariablen		*/
DCL message charstring;			/* Zu sendende Nachricht	*/


START;

TASK message := load_str ( 'f:/user/rieke/diplom/proto/secret.txt' );
TASK public := 'f:/user/rieke/diplom/keys/public';

OUTPUT rsa_mul_512 ( );

TASK n := load_int ( public // '/512/rsa.n' );
TASK e := load_int ( public // '/512/rsa.e' );
					/* Schluessel laden.		*/
TASK i := 0;
TASK block := pack ( message, i, 510 );
MACRO repeat ( loop );
  OUTPUT rsa_mul_next ( mod_exp ( block, e, n ) );
  TASK i := i + 1;
  TASK block := pack ( message, i, 510 );
MACRO until ( block = 0 );
OUTPUT rsa_mul_last;

STOP;


ENDPROCESS;
