/************************************************************************/
/*									*/
/*	RSA\MULTIPLE\RECEIVE.PRO			21.7.93		*/
/*									*/
/*	Andreas Rieke, Heusnerstr. 24, 42283 Wuppertal.			*/
/*									*/
/*	Protokoll zum Entschluesseln einer mit Hilfe des RSA - 		*/
/*	Verfahrens verschluesselten Nachricht.				*/
/*									*/
/*	Vorgaben:							*/
/*	  user:    Name des Anwenders.					*/
/*	  public:  Pfad fuer oeffentliche Schluessel.			*/
/*	  private: Pfad fuer geheime Anwenderschluessel.		*/
/*									*/
/************************************************************************/


PROCESS rsa_mul_receive;


DCL user charstring;			/* Name des Anwenders.		*/
DCL bits_partner integer;		/* Laenge des Primzahlprodukts.	*/
DCL public, private, path charstring;
DCL n, d, block integer;
DCL message charstring;


START;

TASK user := 'Andreas';

TASK public := 'f:/user/rieke/diplom/keys/public';		
					/* Fuer oeffentliche Schluessel.*/
TASK private := 'f:/user/rieke/diplom/keys/private';		
					/* Fuer geheime Schluessel.	*/

NEXTSTATE ready;


STATE ready;
  INPUT rsa_mul ( bits_partner );
    TASK path := '/' // user // '/' // int2str ( bits_partner );
    TASK n := load_int ( public  // path // '/rsa.n' );
    TASK d := load_int ( private // path // '/rsa.d' );
    TASK message := '';
    NEXTSTATE rsa_mul;
ENDSTATE;

STATE rsa_mul;
  INPUT rsa_mul_next ( block );
    TASK message := message // unpack ( mod_exp ( block, d, n ) );
    NEXTSTATE rsa_mul;

  INPUT rsa_mul_last;
    CALL writeln ( 'RSA - Mehrfachuebertragung mit ', bits_partner, 
		   ' Bits:' );
    CALL writeln ( '  ', message );
    NEXTSTATE ready;
ENDSTATE;


ENDPROCESS;
