/************************************************************************/
/*									*/
/*	RSA\MULTIPLE\SEND.PRO				21.7.93		*/
/*									*/
/*	Andreas Rieke, Heusnerstr. 24, 42283 Wuppertal.			*/
/*									*/
/*	Protokoll zum Verschluesseln einer Nachricht nach dem RSA -	*/
/*	Verfahren.							*/
/*									*/
/*	Vorgaben:							*/
/*	  partner: Name des Partners.					*/
/*	  bits:    Laenge der Schluessel in binaerer Darstellung.	*/
/*	  message: Zu verschluesselnde Nachricht.			*/
/* 	  public:  Pfad fuer oeffentliche Schluessel.			*/
/*									*/
/************************************************************************/


PROCESS rsa_mul_send;


DCL partner charstring;			/* Name des Empfaengers.	*/
DCL bits integer;			/* Laenge des Primzahlprodukts.	*/
DCL public, path charstring;		/* Pfade zu den Schluesseln.	*/
DCL n, e, i, block integer;	
DCL message charstring;			/* Zu sendende Nachricht.	*/


START;

TASK partner := 'Andreas';
TASK bits := 512;			/* Anzahl der Bits.		*/
TASK message := load_str ( 'f:/user/rieke/diplom/proto/secret.txt' );
TASK public := 'f:/user/rieke/diplom/keys/public';

TASK path := '/' // partner // '/' // int2str ( bits );
					/* Fuer oeffentliche Schluessel.*/
OUTPUT rsa_mul ( bits );

TASK n := load_int ( public // path // '/rsa.n' );
TASK e := load_int ( public // path // '/rsa.e' );
					/* Schluessel laden.		*/
TASK i := 0;
TASK block := pack ( message, i, bits - 2 );
MACRO repeat ( a );
  OUTPUT rsa_mul_next ( mod_exp ( block, e, n ) );
  TASK i := i + 1;
  TASK block := pack ( message, i, bits - 2 );
MACRO until ( block = 0 );
OUTPUT rsa_mul_last;

STOP;


ENDPROCESS;

