/************************************************************************/
/*									*/
/*	RSA\RECEIVE.PRO					21.7.93		*/
/*									*/
/*	Andreas Rieke, Heusnerstr. 24, 42283 Wuppertal.			*/
/*									*/
/*	Protokoll zum Entschluesseln einer mit Hilfe des RSA - 		*/
/*	Verfahrens verschluesselten Nachricht oder eines Blocks.	*/
/*									*/
/*	Vorgaben:							*/
/*	  user:    Name des Anwenders.					*/
/*	  public:  Pfad fuer oeffentliche Schluessel.			*/
/*	  private: Pfad fuer geheime Anwenderschluessel.		*/
/*									*/
/************************************************************************/


PROCESS rsa_receive;


DCL user charstring;			/* Name des Anwenders.		*/
DCL bits integer;			/* Laenge des Primzahlprodukts.	*/
DCL public, private, path charstring;
DCL n, d, wert integer;
DCL message charstring;


START;

TASK user := 'Andreas';

TASK public := 'f:/user/rieke/diplom/keys/public';		
					/* Fuer oeffentliche Schluessel.*/
TASK private := 'f:/user/rieke/diplom/keys/private';		
					/* Fuer geheime Schluessel.	*/

NEXTSTATE ready;


STATE ready;
  INPUT rsa_sin ( bits, wert );
    TASK path := '/' // user // '/' // int2str ( bits );
    TASK n := load_int ( public  // path // '/rsa.n' );
    TASK d := load_int ( private // path // '/rsa.d' );
    TASK wert := mod_exp ( wert, d, n );
    TASK message := unpack ( wert );
    CALL writeln ( 'RSA-Einfachuebertragung mit ', bits, ' Bits:' );
    CALL writeln ( '  ', message );
    NEXTSTATE ready;
  INPUT rsa_mul ( bits );
    TASK path := '/' // user // '/' // int2str ( bits );
    TASK n := load_int ( public  // path // '/rsa.n' );
    TASK d := load_int ( private // path // '/rsa.d' );
    TASK message := '';
    NEXTSTATE rsa_mul;
ENDSTATE;

STATE rsa_mul;
  INPUT rsa_mul_next ( wert );
    TASK message := message // unpack ( mod_exp ( wert, d, n ) );
    NEXTSTATE rsa_mul;

  INPUT rsa_mul_last;
    CALL writeln ( 'RSA-Mehrfachuebertragung mit ', bits, ' Bits:' );
    CALL writeln ( '  ', message );
    NEXTSTATE ready;
ENDSTATE;


ENDPROCESS;
