/************************************************************************/
/*									*/
/*	RSA\SINGLE\RECEIVE.PRO				21.7.93		*/
/*									*/
/*	Andreas Rieke, Heusnerstr. 24, 42283 Wuppertal.			*/
/*									*/
/*	Protokoll zum Entschluesseln eines mit Hilfe des RSA - 		*/
/*	Verfahrens verschluesselten Blocks.				*/
/*									*/
/*	Vorgaben:							*/
/*	  user:    Name des Anwenders.					*/
/*	  public:  Pfad fuer oeffentliche Schluessel.			*/
/*	  private: Pfad fuer geheime Anwenderschluessel.		*/
/*									*/
/************************************************************************/


PROCESS rsa_sin_receive;


DCL user charstring;			/* Name des Anwenders.		*/
DCL bits_partner integer;		/* Laenge des Primzahlprodukts.	*/
DCL public, private, path charstring;
DCL n, d, wert integer;
DCL message charstring;


START;

TASK user := 'Andreas';

TASK public := 'f:/user/rieke/diplom/keys/public';		
					/* Fuer oeffentliche Schluessel.*/
TASK private := 'f:/user/rieke/diplom/keys/private';		
					/* Fuer geheime Schluessel.	*/

NEXTSTATE ready;


STATE ready;
  INPUT rsa_sin ( bits_partner, wert );
    TASK path := '/' // user // '/' // int2str ( bits_partner );
    TASK n := load_int ( public  // path // '/rsa.n' );
    TASK d := load_int ( private // path // '/rsa.d' );
    TASK wert := mod_exp ( wert, d, n );
    TASK message := unpack ( wert );
    CALL writeln ( 'RSA - Einfachuebertragung mit ', bits_partner, 
		   ' Bits:' );
    CALL writeln ( '  ', message );
    NEXTSTATE ready;
ENDSTATE;


ENDPROCESS;
