/************************************************************************/
/*									*/
/*	RSA\SINGLE\SEND.PRO				21.7.93		*/
/*									*/
/*	Andreas Rieke, Heusnerstr. 24, 42283 Wuppertal.			*/
/*									*/
/*	Protokoll zum Verschluesseln eines Blocks nach dem RSA -	*/
/*	Verfahren.							*/
/*									*/
/*	Vorgaben:							*/
/*	  partner: Name des Partners.					*/
/*	  bits:    Laenge der Schluessel in binaerer Darstellung.	*/
/*	  message: Zu verschluesselnder Block.				*/
/* 	  public:  Pfad fuer oeffentliche Schluessel.			*/
/*									*/
/************************************************************************/


PROCESS rsa_sin_send;


DCL partner charstring;		/* Name des Empfaengers.	*/
DCL bits integer;			/* Laenge des Primzahlprodukts.	*/
DCL public, path charstring;
DCL n, e, wert integer;
DCL message charstring;


START;

TASK partner := 'andreas';
TASK bits := 512;			/* Anzahl der Bits.		*/

TASK message := load_str ( 'f:/user/rieke/diplom/proto/secret.txt' );

TASK public := 'f:/user/rieke/diplom/keys/public';

TASK path := '/' // partner // '/' // int2str ( bits );
					/* Fuer oeffentliche Schluessel.*/
TASK n := load_int ( public // path // '/rsa.n' );
TASK e := load_int ( public // path // '/rsa.e' );

TASK wert := pack ( message, 0, bits - 2 );
TASK wert := mod_exp ( wert, e, n );
					/* Nur den ersten Block senden.	*/
OUTPUT rsa_sin ( bits, wert );
STOP;


ENDPROCESS;
