/************************************************************************/
/*									*/
/*	SCHNORR\IDENTIFY\BOTH\PROVER.PRO		22. 1. 95	*/
/*									*/
/*	Andreas Rieke, Heusnerstr. 24, 42283 Wuppertal.			*/
/*									*/
/*	Sendet den vom Trust unterschriebenen ffentlichen Schlssel	*/
/*	an den Partner und fhrt dann die Authentifikation durch.	*/
/*									*/
/*	Vorgaben:							*/
/*	  user:    Name des Anwenders (Kurzform)			*/
/*	  private: Pfad fuer geheime Schluessel.			*/
/*	  public:  Pfad fuer oeffentliche Schluessel.			*/
/*									*/
/************************************************************************/


PROCESS schnorr_identify_both_prover;


DCL user, id, private, public charstring;
DCL q, p, a integer;
DCL v_user, e, y integer;
DCL s integer;
DCL r, x integer;


START;

TASK user := 'Andreas';

TASK private := 'f:/user/rieke/diplom/keys/private';
TASK public := 'f:/user/rieke/diplom/keys/public';

TASK q := load_int ( public // '/schnorr.q' );
TASK p := load_int ( public // '/schnorr.p' );
TASK a := load_int ( public // '/schnorr.a' );

TASK id := load_str ( public // '/' // user // '/schnorr.i' );
TASK v_user := load_int ( public // '/' // user // '/schnorr.v' );
TASK e := load_int ( public // '/' // user // '/schnorr.e' );
TASK y := load_int ( public // '/' // user // '/schnorr.y' );

TASK s := load_int ( private // '/' // user // '/schnorr.s' );

OUTPUT schnorr_identify_both_1 ( user, id, v_user, e, y );

TASK r := rand_max ( q - 1 ) + 1;
TASK x := mod_exp ( a, r, p );

OUTPUT schnorr_identify_both_2 ( x );

NEXTSTATE schnorr_identify_both_b;


STATE schnorr_identify_both_b;
  INPUT schnorr_identify_both_3 ( e );
    TASK y := ( r + s * e ) mod q;
    OUTPUT schnorr_identify_both_4 ( y );
    OUTPUT quit;
    STOP;
ENDSTATE;


ENDPROCESS;
