/************************************************************************/
/*									*/
/*	SCHNORR\IDENTIFY\BOTH\VERIFIER.PRO		22. 1. 95	*/
/*									*/
/*	Andreas Rieke, Heusnerstr. 24, 42283 Wuppertal.			*/
/*									*/
/*	Prueft den ffentlichen, vom Trust unterschriebenen Schlssel	*/
/*	und fhrt die Authentifikation nach dem Protokoll von Schnorr	*/
/*	durch.								*/
/*									*/
/*	Vorgaben:							*/
/*	  public: Pfad fuer oeffentliche Schluessel.			*/
/*									*/
/************************************************************************/


PROCESS schnorr_identify_both_verifier;


DCL partner, id, public charstring;
DCL p, a, v_trust integer;
DCL v_user, e, y, x, t integer;


START;

TASK public := 'f:/user/rieke/diplom/keys/public';

TASK p := load_int ( public // '/schnorr.p' );
TASK a := load_int ( public // '/schnorr.a' );
TASK v_trust := load_int ( public // '/schnorr.v' );

NEXTSTATE ready;


STATE ready;
  INPUT schnorr_identify_both_1 ( partner, id, v_user, e, y );

    TASK x := ( mod_exp ( a, y, p ) * mod_exp ( v_trust, e, p ) ) mod p;

    DECISION e = hash_md5 ( int2str ( x ) // int2str ( v_user ) // id );
      (true):
        CALL writeln ( 'Prfung der ffentlichen Schlssel von ', partner,
                       ': positiv.' );
        NEXTSTATE schnorr_identify_both_a;
      ELSE:
        CALL writeln ( 'Prfung der ffentlichen Schlssel von ', partner, 
                       ': negativ.' );
        NEXTSTATE ready;
    ENDDECISION;
  INPUT quit;
    NEXTSTATE ready;
ENDSTATE;


STATE schnorr_identify_both_a;
  INPUT schnorr_identify_both_2 ( x );
    TASK t := 128;
    TASK e := rand_max ( exp ( 2, t ) );
    OUTPUT schnorr_identify_both_3 ( e );
    NEXTSTATE schnorr_identify_both_c;
ENDSTATE;


STATE schnorr_identify_both_c;
  INPUT schnorr_identify_both_4 ( y );
    DECISION x = mod_exp ( a, y, p ) * mod_exp ( v_user, e, p ) mod p;
      (true):
        CALL writeln ( 'Schnorr-Authentifikation von ', partner, ' mit ',
		       t, ' Bits: positiv.' );
        NEXTSTATE auth;
      ELSE:
        CALL writeln ( 'Schnorr-Authentifikation von ', partner, ' mit ',
		       t, ' Bits: negativ.' );
        NEXTSTATE ready;
    ENDDECISION;
ENDSTATE;


STATE auth;
  INPUT quit;
    NEXTSTATE ready;
ENDSTATE;


ENDPROCESS;
