/************************************************************************/
/*									*/
/*	SCHNORR\IDENTIFY\SIMPLE\PROVER.PRO		22. 1. 95	*/
/*									*/
/*	Andreas Rieke, Heusnerstr. 24, 42283 Wuppertal.			*/
/*									*/
/*	Fhrt eine Authentifizierung nach dem Protokoll von Schnorr 	*/
/*	durch. Die Echtheit des ffentlichen Schlssels wird nicht 	*/
/*	bewiesen.							*/
/*									*/
/*	Vorgaben:							*/
/*	  user:    Name des Anwenders.					*/
/*	  private: Pfad fuer geheime Schluessel.			*/
/*	  public:  Pfad fuer oeffentliche Schluessel.			*/
/*									*/
/************************************************************************/


PROCESS schnorr_identify_simple_prover;


DCL user, private, public charstring;
DCL q, p, a, s integer;
DCL r, x, y, e integer;


START;

TASK user := 'Andreas';

TASK private := 'f:/user/rieke/diplom/keys/private';
TASK public := 'f:/user/rieke/diplom/keys/public';

TASK q := load_int ( public // '/schnorr.q' );
TASK p := load_int ( public // '/schnorr.p' );
TASK a := load_int ( public // '/schnorr.a' );
TASK s := load_int ( private // '/' // user // '/schnorr.s' );

TASK r := rand_max ( q - 1 ) + 1;
TASK x := mod_exp ( a, r, p );
OUTPUT schnorr_identify_1 ( user, x );

NEXTSTATE schnorr_identify_a;


STATE schnorr_identify_a;
  INPUT schnorr_identify_2 ( e );
    TASK y := ( r + s * e ) mod q;
    OUTPUT schnorr_identify_3 ( y );
    OUTPUT quit;
    STOP;
ENDSTATE;


ENDPROCESS;
