/************************************************************************/
/*									*/
/*	SCHNORR\IDENTIFY\SIMPLE\VERIFIER.PRO		22. 1. 95	*/
/*									*/
/*	Andreas Rieke, Heusnerstr. 24, 42283 Wuppertal.			*/
/*									*/
/*	Fhrt eine Authentifizierung nach dem Protokoll von Schnorr 	*/
/*	durch. Die Echtheit des ffentlichen Schlssels des Partners	*/
/*	wird nicht geprft.						*/
/*									*/
/*	Vorgaben:							*/
/*	  public: Pfad fuer oeffentliche Schluessel.			*/
/*									*/
/************************************************************************/


PROCESS schnorr_identify_simple_verifier;


DCL partner, public charstring;
DCL q, p, a integer;
DCL x, t, e, y, v_user integer;


START;

TASK public := 'f:/user/rieke/diplom/keys/public';

TASK q := load_int ( public // '/schnorr.q' );
TASK p := load_int ( public // '/schnorr.p' );
TASK a := load_int ( public // '/schnorr.a' );

NEXTSTATE ready;


STATE ready;
  INPUT schnorr_identify_1 ( partner, x );
    TASK v_user := load_int ( public // '/' // partner // '/schnorr.v' );
    TASK t := 128;
    TASK e := rand_max ( exp ( 2, t ) );
    OUTPUT schnorr_identify_2 ( e );
    NEXTSTATE schnorr_identify_b;
  INPUT quit;
    NEXTSTATE ready;
ENDSTATE;

STATE schnorr_identify_b;
  INPUT schnorr_identify_3 ( y );
    DECISION x = mod_exp ( a, y, p ) * mod_exp ( v_user, e, p ) mod p;
      (true):
        CALL writeln ( 'Schnorr-Authentifikation von ', partner, ' mit ',
		       t, ' Bits: positiv.' );
        NEXTSTATE auth;
      ELSE:
        CALL writeln ( 'Schnorr-Authentifikation von ', partner, ' mit ',
		       t, ' Bits: negativ.' );
        NEXTSTATE ready;
    ENDDECISION;
ENDSTATE;

STATE auth;
  INPUT quit;
    NEXTSTATE ready;
ENDSTATE;


ENDPROCESS;
