/************************************************************************/
/*									*/
/*	SCHNORR\IDENTIFY\STEP_1\VERIFIER.PRO		22. 1. 95	*/
/*									*/
/*	Andreas Rieke, Heusnerstr. 24, 42283 Wuppertal.			*/
/*									*/
/*	Prueft den ffentlichen, vom Trust unterschriebenen Schlssel	*/
/*	nach dem Protokoll von Schnorr.					*/
/*									*/
/*	Vorgaben:							*/
/*	  user:    Name des Anwenders (Kurzform)			*/
/*	  public:  Pfad fuer oeffentliche Schluessel.			*/
/*									*/
/************************************************************************/


PROCESS schnorr_identify_step1_verifier;


DCL user, partner, id, public charstring;
DCL q, p, a, v_trust integer;
DCL v_user, e, y, x integer;


START;

TASK user := 'Andreas';

TASK public := 'f:/user/rieke/diplom/keys/public';

TASK q := load_int ( public // '/schnorr.q' );
TASK p := load_int ( public // '/schnorr.p' );
TASK a := load_int ( public // '/schnorr.a' );
TASK v_trust := load_int ( public // '/schnorr.v' );

NEXTSTATE ready;


STATE ready;
  INPUT schnorr_public_key ( partner, id, v_user, e, y );

    TASK x := ( mod_exp ( a, y, p ) * mod_exp ( v_trust, e, p ) ) mod p;

    DECISION e = hash_md5 ( int2str ( x ) // int2str ( v_user ) // id );
      (true):
        CALL writeln ( 'Prfung der ffentlichen Schlssel von ', partner,
                       ': positiv.' );
        CALL mkdir ( public // '/' // user // '/schnorr' );
        CALL store ( v_user, public // '/' // user // '/schnorr/' // 
		    partner // '.v' );
      ELSE:
        CALL writeln ( 'Prfung der ffentlichen Schlssel von ', partner, 
                       ': negativ.' );
    ENDDECISION;
    NEXTSTATE ready;
ENDSTATE;


ENDPROCESS;
