/************************************************************************/
/*									*/
/*	SCHNORR\KEYS\COMMON.PRO				22. 1. 95	*/
/*									*/
/*	Andreas Rieke, Heusnerstr. 24, 42283 Wuppertal.			*/
/*									*/
/*	Berechnet die gemeinsamen Schluesssel fuer die Algorithmen 	*/
/*	von Schnorr.							*/
/*									*/
/*	Vorgaben:							*/
/*	  public: Pfad fuer oeffentliche Schluessel.			*/
/*	  trust:  Pfad fuer Schluessel der Schluesselzentrale.		*/
/*									*/
/************************************************************************/


PROCESS schnorr_keys_common;


DCL public, trust charstring;
DCL q, minimum, maximum, n, p, a, b, s, v integer;


START;

TASK public := 'f:/user/rieke/diplom/keys/public';
TASK trust := 'f:/user/rieke/diplom/keys/trust';

CALL mkdir ( public );
CALL mkdir ( trust );

TASK q := rand_bits_prime ( 141 );	/* q >= exp ( 2, 140 )		*/

TASK minimum := ( exp ( 2, 512 ) - 1 ) / ( 2 * q ) + 1;
TASK maximum := ( exp ( 2, 513 ) - 1 ) / ( 2 * q ) + 1;
MACRO repeat ( a );
  TASK n := minimum + rand_max ( maximum - minimum );
  TASK p := 2 * n * q + 1;
MACRO until ( is_prime ( p ) );

MACRO repeat ( b );
  TASK b := rand_max ( p );
  TASK a := mod_exp ( b, ( p - 1 ) / q, p );
MACRO until ( a /= 1 );

TASK s := rand_max ( q ) + 1;
TASK v := rcp ( mod_exp ( a, s, p ), p );

CALL store ( q, public // '/schnorr.q' );
CALL store ( p, public // '/schnorr.p' );
CALL store ( a, public // '/schnorr.a' );
CALL store ( s, trust // '/schnorr.s' );
CALL store ( v, public // '/schnorr.v' );

STOP;


ENDPROCESS;
