/************************************************************************/
/*									*/
/*	SCHNORR\SIGN\SIGN.PRO				22. 1. 95	*/
/*									*/
/*	Andreas Rieke, Heusnerstr. 24, 42283 Wuppertal.			*/
/*									*/
/*	Berechnet die digitale Unterschrift nach dem Protokoll		*/
/*	von Schnorr.							*/
/*									*/
/*	Vorgaben:							*/
/*	  user:    Name des Anwenders (Kurzform)			*/
/*	  private: Pfad fuer geheime Schluessel.			*/
/*	  public:  Pfad fuer oeffentliche Schluessel.			*/
/*	  message: Zu unterschreibende Nachricht.			*/
/*									*/
/************************************************************************/


PROCESS schnorr_sign_sign;


DCL user, private, public, message charstring;
DCL q, p, a, s integer;
DCL r, x, e, y integer;


START;

TASK user := 'Andreas';

TASK private := 'f:/user/rieke/diplom/keys/private';
TASK public := 'f:/user/rieke/diplom/keys/public';

TASK message := 'Dies ist der zu unterschreibende Text.';

TASK q := load_int ( public // '/schnorr.q' );
TASK p := load_int ( public // '/schnorr.p' );
TASK a := load_int ( public // '/schnorr.a' );
TASK s := load_int ( private // '/' // user // '/schnorr.s' );

TASK r := rand_max ( q ) + 1;
TASK x := mod_exp ( a, r, p );
TASK e := hash_md5 ( int2str ( x ) // message );
TASK y := ( r + s * e ) mod q;

OUTPUT schnorr_signature ( message, user, e, y );

STOP;


ENDPROCESS;
