/************************************************************************/
/*									*/
/*	SCHNORR\SIGN\VERIFY.PRO				22. 1. 95	*/
/*									*/
/*	Andreas Rieke, Heusnerstr. 24, 42283 Wuppertal.			*/
/*									*/
/*	Prueft die digitale Unterschrift nach dem Protokoll		*/
/*	von Schnorr.							*/
/*									*/
/*	Vorgaben:							*/
/*	  public:  Pfad fuer oeffentliche Schluessel.			*/
/*									*/
/************************************************************************/


PROCESS schnorr_sign_verify;


DCL partner, public, message charstring;
DCL q, p, a, v integer;
DCL x, e, y integer;


START;

TASK public := 'f:/user/rieke/diplom/keys/public';

TASK q := load_int ( public // '/schnorr.q' );
TASK p := load_int ( public // '/schnorr.p' );
TASK a := load_int ( public // '/schnorr.a' );

NEXTSTATE ready;

STATE ready;
  INPUT schnorr_signature ( message, partner, e, y );

    TASK v := load_int ( public // '/' // partner // '/schnorr.v' );

    TASK x := ( mod_exp ( a, y, p ) * mod_exp ( v, e, p ) ) mod p;

    DECISION e = hash_md5 ( int2str ( x ) // message );
      (true):
        CALL writeln ( 'Schnorr-Unterschrift von ', partner, ': positiv.' );
      ELSE:
        CALL writeln ( 'Schnorr-Unterschrift von ', partner, ': negativ.' );
    ENDDECISION;
    CALL writeln ( '  ', message );
    NEXTSTATE ready;
ENDSTATE;


ENDPROCESS;
